#include "ImageMap.h"
#include "debug.h"

extern unsigned char maxsectors[40];

ImageMap::ImageMap(void)
{
	Tracks = 0;
	Sectors = 0;
	Map = 0;
}

ImageMap::~ImageMap(void)
{
	if (Sectors) delete[] Sectors;
	if (Map) delete[] Map;
}

ImageMap::ImageMap(short trk, short sec)
{
	short i;

	Tracks = trk;
	Sectors = new unsigned char[Tracks];
	Map = new unsigned char[Tracks*sec];

	for (i=0;i<Tracks;i++) Sectors[i] = sec;

	Clear();
}

ImageMap::ImageMap(short trks, const unsigned char *maxsectors)
{
	short i;

	Tracks = trks;
	Sectors = new unsigned char[Tracks];

	if (Tracks <= 40) {
		for (i=0;i<Tracks;i++) Sectors[i] = maxsectors[i];
	} else {
		if (Tracks == 70) {
			for (i=0;i<35;i++) Sectors[i] = maxsectors[i];
			for (i=35;i<Tracks;i++) Sectors[i] = maxsectors[i-35];
		}
		if (Tracks == 80) {
			for (i=0;i<40;i++) Sectors[i] = maxsectors[i];
			for (i=40;i<Tracks;i++) Sectors[i] = maxsectors[i-40];
		}
	}

	Map = new unsigned char[Tracks*Sectors[0]];

	Clear();
}

void ImageMap::Clear(void)
{
	short k, i, sec;

	sec = Sectors[0];

	for (k=0;k<Tracks;k++) {
		for (i=0;i<Sectors[k];i++) {
			Map[k*sec + i] = 0;
		}
	}
}

bool ImageMap::Exists(short trk, short sec)
{
	trk--;

	if ((trk < 0) || (trk >= Tracks)) return false;
	if ((sec < 0) || (sec >= Sectors[trk])) return false;

	return true;
}

void ImageMap::Set(short trk, short sec)
{
	trk--;

	if (!Exists(trk, sec)) return;

	Map[trk*Sectors[0] + sec] = 1;
}

bool ImageMap::Get(short trk, short sec)
{
	trk--;

	if (!Exists(trk, sec)) return true;

	return (Map[trk*Sectors[0] + sec] != 0);
}

